'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createNotFoundResponse = exports.createErrorResponse = exports.createSuccessResponse = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const createSuccessResponse = exports.createSuccessResponse = data => ({
  statusCode: 200,
  headers: {
    'Content-Type': typeof data === 'string' ? 'text/plain' : 'application/json'
  },
  body: !Array.isArray(data) ? typeof data === 'string' ? data : (0, _stringify2.default)(data) : (0, _stringify2.default)({
    data
  })
});

const createErrorResponse = exports.createErrorResponse = err => ({
  statusCode: err && err.statusCode ? err.statusCode : 500,
  headers: {
    'Content-Type': 'application/json'
  },
  body: (0, _stringify2.default)(err && err.statusCode && err.message ? err.message : 'Server error')
});

const createNotFoundResponse = exports.createNotFoundResponse = () => ({
  statusCode: 404,
  headers: {
    'Content-Type': 'application/json'
  },
  body: (0, _stringify2.default)({
    message: 'Resource not found'
  })
});