'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _apiResponseWrapper = require('./apiResponseWrapper');

var _isResultEmpty = require('./isResultEmpty');

var _isResultEmpty2 = _interopRequireDefault(_isResultEmpty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const factory = (service, validate, changeHttpResponse = (() => {
  var _ref = (0, _asyncToGenerator3.default)(function* (event, resp) {
    return resp;
  });

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
})()) => {
  return (() => {
    var _ref2 = (0, _asyncToGenerator3.default)(function* (event, context, callback) {
      context.callbackWaitsForEmptyEventLoop = false;
      let newEvent = event;
      try {
        if (!event.queryStringParameters) {
          event.queryStringParameters = {};
        }
        if (!event.pathParameters) {
          event.pathParameters = {};
        }
        if (event && event.headers && event.headers['Content-Type'] === 'application/json') {
          try {
            newEvent = (0, _extends3.default)({}, event, { body: JSON.parse(event.body) });
          } catch (err) {
            const error = new Error('There was an issue with request body, it cant be parsed into valid JSON');
            error.statusCode = 400;
            throw error;
          }
        }
        if (validate) {
          try {
            const errors = yield validate(newEvent, context);
            if (errors) {
              const error = new Error(`Validation error: 
              ${(0, _stringify2.default)(errors, null, 2)}`);
              error.statusCode = 400;
              throw error;
            }
          } catch (error) {
            error.statusCode = 400;
            throw error;
          }
        }
        const result = yield service(newEvent, context);
        if (!(0, _isResultEmpty2.default)(result)) {
          callback(null, (yield changeHttpResponse(event, (0, _apiResponseWrapper.createSuccessResponse)(result))));
        } else {
          callback(null, (0, _apiResponseWrapper.createNotFoundResponse)());
        }
      } catch (error) {
        callback(null, (0, _apiResponseWrapper.createErrorResponse)(error));
      }
    });

    return function (_x3, _x4, _x5) {
      return _ref2.apply(this, arguments);
    };
  })();
};
module.exports = factory;